from time import sleep
from .Frames_capture_fixture import FixtureFramesCapture
from xtr import logging, Severity
logger = logging.getLogger(__name__)

# Create the test case class, that inherits from the preset TestFixture.


class TestCaptureNpduFrame(FixtureFramesCapture):

    # Create setUp() method.
    def setUp(self):
        logger.info("Setup test case")

    # Create the tearDown() method.
    def tearDown(self):
        logger.info("Tear down test case")

# Create the test case core method that holds the main test steps.
    def test_capture_Npdu_frame(self):

        self.npdu_manager.add_input_pdu_tunnel(
            channel_name="tunnel_Receiver",
            multi_cast_ip_v4_addresses=["239.192.255.2"],
            multi_cast_port=31338,
            remote_ip_v4_address="160.48.249.57",
            local_port=31302,
            with_vlan_assign=False,
            force_add=False,
            adapter_name="Ethernet_MTF")

        self.npdu_manager.start_npdu_listener("tunnel_Receiver")

        ecu = self.com_network.try_get_ecu_by_name("ECU3_ETHERNET")

        ecu.start_npdus({0x7ca, 0x7A1}, channel_name="InVehicle")

        sleep(1)

        ecu.stop_npdus({0x7A1, 0x7ca}, channel_name="InVehicle")

        self.npdu_manager.stop_npdu_listener("tunnel_Receiver")

        npdus = self.npdu_manager.get_all_received_npdu_data(
            "tunnel_Receiver", True)

        for pdu in npdus:
            logger.info(pdu.npdu_element.pdu_id)
            logger.info(pdu.npdu_element.payload)
            logger.info(pdu.npdu_element.bus_spec_id)
            logger.info(pdu.npdu_element.direction)
            logger.info(pdu.npdu_element.pdu_index)
            logger.info(pdu.npdu_element.tci.dei)
            logger.info(pdu.npdu_element.tci.pcp)
            logger.info(pdu.npdu_element.tci.vid)
